<template>
  <div v-bind:class="{
    'main-card': isInsideMainPage,
    'cart-card': isInsideCartPage,
    'product-card': isInsideProductPage
  }">
  <router-link :to="`/card/${id}`">
    <img :src="imgSrc" class="image">
  </router-link>
    <div class="text-container">
      <h2 class="title">
        {{ title }}
      </h2>
      <p class="description" v-if="isInsideMainPage">
        {{ description }}
      </p>
      <div class="button-container">
        <span class="price">
          {{ prettyPrice }} ₽
        </span>
        <add-icon @click="addItem" v-if="isInsideMainPage" />
        <remove-icon @click="removeItem" v-if="isInsideCartPage" />
      </div>
    </div>
  </div>
</template>

<script>
import { prettifySum } from '@/assets/js/util.js'
import AddIcon from '@/components/icons/AddIcon'
import RemoveIcon from '@/components/icons/RemoveIcon'
import { useStore } from 'vuex'

export default {
  components: {
    AddIcon, RemoveIcon
  },
  props: {
    id: {
      type: Number,
      default: 0
    },
    title: {
      type: String,
      default: ''
    },
    description: {
      type: String,
      default: ''
    },
    price: {
      type: Number,
      default: 0
    },
    imgSrc: {
      type: String,
      default: ''
    },
    isInsideMainPage: {
      type: Boolean,
      default: true
    },
    isInsideCartPage: {
      type: Boolean,
      default: false
    },
    isInsideProductPage: {
      type: Boolean,
      default: false
    }
  },
  setup (props) {
    const store = useStore()
    const addItem = () => store.commit('SetAddItem', props.id)
    const removeItem = () => store.commit('SetRemoveItem', props.id)
    return {
      addItem,
      removeItem,
      prettyPrice: prettifySum(props.price)
    }
  }
}
</script>

<style lang="scss" scoped>
.main-card {
  width: 312px;
  height: 552px;
  border: 1px solid #D58C51;

  .image {
    display: block;
    margin: 43px auto 0 auto;
    width: 270px;
    height: 272px;
  }

  .text-container {
    margin-left: 20px;
    margin-right: 32px;
    color: #FFFFFF;
    font-family: Montserrat;

    .title {
      margin-top: 30px;
      width: 270px;
      height: 42px;
      font-size: 17px;
      font-weight: 500;
    }

    .description {
      margin-top: 9px;
      width: 270px;
      height: 80px;
      font-size: 14px;
      font-weight: 400;
    }

    .button-container {
      margin-top: 14px;
      display: flex;
      justify-content: space-between;
      align-items: center;

      .price {
        font-size: 17px;
        font-weight: 500;
      }
    }
  }
}

.cart-card {
  margin-top: 35px;
  display: flex;
  align-items: center;
  gap: 0 85px;

  .image {
    width: 132px;
    height: 132px;
  }

  .text-container {
    width: 100%;
    display: flex;
    justify-content: space-between;
    align-items: center;
    font-family: Montserrat;

    .title {
      font-size: 17px;
      font-weight: 500;
      color: #FFFFFF;
    }

    .button-container {
      display: flex;
      align-items: center;
      gap: 0 15px;

      .price {
        color: #D58C51;
        font-size: 18px;
        font-weight: 400;
      }
    }
  }
}

.product-card {
  display: flex;
  align-items: center;
  gap: 0 85px;

  .image {
    width: 132px;
    height: 132px;
  }

  .text-container {
    width: 100%;
    display: flex;
    justify-content: space-between;
    align-items: center;
    font-family: Montserrat;

    .title {
      font-size: 17px;
      font-weight: 500;
      color: #FFFFFF;
    }

    .button-container {
      display: flex;
      align-items: center;
      gap: 0 15px;

      .price {
        color: #D58C51;
        font-size: 18px;
        font-weight: 400;
      }
    }
  }
}
</style>
